## varconf 1503485705.dac8873

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(varconf)
include(GNUInstallDirs)
include(FindPkgConfig)

# Version setup

set(VARCONF_VERSION_MAJOR 1)
set(VARCONF_VERSION_MINOR 0)
set(VARCONF_VERSION_PATCH 2)

set(VERSION ${VARCONF_VERSION_MAJOR}.${VARCONF_VERSION_MINOR}.${VARCONF_VERSION_PATCH})
set(SUFFIX -${VARCONF_VERSION_MAJOR}.${VARCONF_VERSION_MINOR})

set(VARCONF_ABI_CURRENT 8)
set(VARCONF_ABI_REVISION 0)
set(VARCONF_ABI_AGE 0)
math(EXPR VARCONF_SOVERSION ${VARCONF_ABI_CURRENT}-${VARCONF_ABI_AGE})
set(VARCONF_ABI_VERSION ${VARCONF_SOVERSION}.${VARCONF_ABI_AGE}.${VARCONF_ABI_REVISION})

# Set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall")

include_directories("${PROJECT_SOURCE_DIR}")

# Meta data

set(DESCRIPTION "Configuration library for the Worldforge system.")



# This macro defines a library
macro(wf_add_library _LIB_NAME _SOURCE_FILES_VAR _HEADER_FILES_VAR)

    add_library(${_LIB_NAME} SHARED ${${_SOURCE_FILES_VAR}})
    set_target_properties(${_LIB_NAME} PROPERTIES
            VERSION ${VARCONF_ABI_VERSION}
            SOVERSION ${VARCONF_SOVERSION}
            )

    install(TARGETS ${_LIB_NAME}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    foreach (file ${${_HEADER_FILES_VAR}})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION include/${PROJECT_NAME}${SUFFIX}/${dir})
    endforeach ()

    set(PKG_CONFIG_LIBS "-l${_LIB_NAME} ${PKG_CONFIG_LIBS}")

    target_link_libraries(${_LIB_NAME} ${WF_LIBRARIES})

endmacro()

# Add a "check" target, which builds and runs the tests.
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

#Macro for adding a test. The test name will be extracted from the name of the first submitted file.
#Additional files can be submitted as varargs.
macro(wf_add_test TEST_FILE)

    get_filename_component(TEST_NAME ${TEST_FILE} NAME_WE)

    add_executable(${TEST_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} ${ARGN})
    target_link_libraries(${TEST_NAME} ${PROJECT_NAME}${SUFFIX})
    add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})

    add_dependencies(check ${TEST_NAME})
endmacro()


# Check for deps
pkg_check_modules(WF REQUIRED sigc++-2.0>=2.0.0)

link_directories(${WF_LIBRARY_DIRS})
include_directories(${WF_INCLUDE_DIRS})
# Populate for pkg-config
set(REQUIRES "sigc++-2.0")

# Define source files for libraries

set(SOURCE_FILES
        varconf/config.cpp
        varconf/dynbase.cpp
        varconf/dyncmp.cpp
        varconf/dyntypes.cpp
        varconf/parse_error.cpp
        varconf/varconf.h
        varconf/variable.cpp)

set(HEADER_FILES
        varconf/config.h
        varconf/dynbase.h
        varconf/dyncmp.h
        varconf/dyntypes.h
        varconf/dynvar.h
        varconf/parse_error.h
        varconf/varconf.h
        varconf/varconf_defs.h
        varconf/variable.h)

wf_add_library(${PROJECT_NAME}${SUFFIX} SOURCE_FILES HEADER_FILES)


# pkg-config files
configure_file(${PROJECT_NAME}.pc.in ${PROJECT_NAME}${SUFFIX}.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}${SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# RPM spec files
#TODO: fix these
configure_file(${PROJECT_NAME}.spec.in ${PROJECT_NAME}.spec @ONLY)
#TODO: fix these
configure_file(mingw32-${PROJECT_NAME}.spec.in mingw32-${PROJECT_NAME}.spec @ONLY)

# Add test
enable_testing()



wf_add_test(tests/conftest.cpp)
add_definitions(-DSRCDIR="${PROJECT_SOURCE_DIR}/tests")

# Doxygen support, exports a "docs" target.

find_package(Doxygen)
set(DOXYGEN_INPUT varconf)
configure_file(Doxyfile.in Doxyfile @ONLY)

if (DOXYGEN_FOUND)

    set(DOXYGEN_INPUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    set(DOXYGEN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc)

    add_custom_command(
            OUTPUT ${DOXYGEN_OUTPUT}
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
            COMMAND ${CMAKE_COMMAND} -E echo "Done."
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${DOXYGEN_INPUT}
    )

    add_custom_target(docs DEPENDS ${DOXYGEN_OUTPUT})

endif (DOXYGEN_FOUND)

add_custom_command(
        OUTPUT ChangeLog
        COMMAND ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR} 8bd480b053190ffde2afe33af66f484953036f5a
)
add_custom_target(changelog DEPENDS ChangeLog)


# Packaging (for source tarballs

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${DESCRIPTION})
set(CPACK_PACKAGE_VENDOR "Worldforge")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${VARCONF_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${VARCONF_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${VARCONF_VERSION_PATCH}")
#set(CPACK_INSTALL_SCRIPT "sh ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CPACK_PACKAGE_INSTALL_DIRECTORY} 8bd480b053190ffde2afe33af66f484953036f5a")

set(CPACK_SOURCE_GENERATOR TBZ2 ZIP)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}" CACHE INTERNAL "tarball basename")

set(CPACK_SOURCE_IGNORE_FILES
        # no hidden files
        "/\\\\..+$"
        "~$"
        )

include(CPack)

## varconf 0.6.7

=== debian/changelog ===
varconf (0.6.7-2) unstable; urgency=low

  * optioned more symbols for GCC 4.7 builds (closes: #667408)
  * debian/control: updates Standards-Version to 3.9.3 (no changes)
  * incorporate and acknowledge NMU (thanks Matthias)

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Wed, 30 May 2012 09:28:48 -0400

varconf (0.6.7-1.1) unstable; urgency=low

  * Non maintainer upload
  * Fix build failure with GCC 4.7. Closes: #667408.

 -- Matthias Klose <doko@debian.org>  Wed, 30 May 2012 06:13:46 +0000

varconf (0.6.7-1) unstable; urgency=low

  * new upstream release
  * converted packaging to use dh sequenceer
  * new maintainer: Debian games team (closes: #653978)
    - added myself as uploader
  * converted to 3.0 (quilt) source format
  * changed package names due to SONAME version bump
  * updated Standards-Version to 3.9.2 (no changes required)
  * debian/control:  added Vcs- fields
  * added symbols tracking
  * debian/copyright: convert to DEP-5 format
  * debian/rules: regenerate autoconfigury
  * use xz compression for packaging
  * move to debhelper compat level 9

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Fri, 27 Jan 2012 21:38:19 -0500

varconf (0.6.6-2) unstable; urgency=low

  * debian/libvarconf-dev.install: Don't install *.la file.
  * debian/control: Updated Standards-Version to 3.8.3.

 -- Michael Koch <konqueror@gmx.de>  Tue, 25 Aug 2009 21:49:55 +0200

varconf (0.6.6-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Updated Build-Depends on debhelper to >= 5.
  * debian/control: Updated Standards-Version to 3.8.2.
  * debian/control: Move libvarconf-1.0-6-dbg to debug section.
  * debian/watch: Use SourceForge redirector.

 -- Michael Koch <konqueror@gmx.de>  Wed, 22 Jul 2009 16:51:55 +0200

varconf (0.6.5-4) unstable; urgency=low

  * Added patch to be able to build with GCC 4.3. Closes: #474867
  * Use chrpath to delete rpath.
  * Clarified debian/copyright.

 -- Michael Koch <konqueror@gmx.de>  Tue, 08 Apr 2008 10:33:45 +0200

varconf (0.6.5-3) unstable; urgency=low

  * Replaced ${Source-Version} in debian/control.
  * Updated clean target in debian/rules to give better error message on
    error.
  * Updated Standards-Version to 3.7.3.
  * Added Homepage field.

 -- Michael Koch <konqueror@gmx.de>  Mon, 24 Dec 2007 11:18:54 +0100

varconf (0.6.5-2) unstable; urgency=low

  * Upload to unstable.

 -- Michael Koch <konqueror@gmx.de>  Mon, 04 Jun 2007 21:50:10 +0200

varconf (0.6.5-1) experimental; urgency=low

  * Upload to experimental.
  * New upstream release.
  * Build-Depends on debhelper >= 4.0.0.
  * Fixed creation of debug package.
  * Updated Standards-Version to 3.7.2.

 -- Michael Koch <konqueror@gmx.de>  Tue, 13 Feb 2007 09:02:23 +0000

varconf (0.6.4-1) unstable; urgency=low

  * New upstream release

 -- Michael Koch <konqueror@gmx.de>  Mon, 23 Jan 2006 09:46:15 +0000

varconf (0.6.3-2) unstable; urgency=low

  * Use libsigc++-2.0 instead of libsigc++-1.2. This changes soname.
    (Closes: #339274).
  * debian/compat: Use compat level 4.

 -- Michael Koch <konqueror@gmx.de>  Sat,  3 Dec 2005 22:07:54 +0000

varconf (0.6.3-1) unstable; urgency=low

  * New upstream release
    - Updated to new SONAME
  * Updated watch file to use SourceForge
  * Tightened (Build-)Depends on libsigc++-1.2-dev to use (>= 1.2.5-5)

 -- Michael Koch <konqueror@gmx.de>  Wed, 12 Oct 2005 06:08:14 +0000

varconf (0.6.2-3) unstable; urgency=low

  * Fixed typo in package description of libvarconf-1.0-2
    (Closes: #325660)
  * Fixed address of FSF in debian/copyright
  * Sponsored by Petter Reinholtsen

 -- Michael Koch <konqueror@gmx.de>  Thu,  1 Sep 2005 08:09:49 +0000

varconf (0.6.2-2) unstable; urgency=low

  * Renamed packages due to C++ transition
  * Updated Standards-Version to 3.6.2
  * Sponsored by Petter Reinholtsen

 -- Michael Koch <konqueror@gmx.de>  Sat, 27 Aug 2005 10:22:46 +0000

varconf (0.6.2-1) unstable; urgency=low

  * New upstream release
  * Use --disable-dependency-tracking

 -- Michael Koch <konqueror@gmx.de>  Mon, 25 Oct 2004 12:30:41 +0000

varconf (0.6.1-3) unstable; urgency=high

  * Reworked package descriptions
  * Added debian/watch

 -- Michael Koch <konqueror@gmx.de>  Thu, 30 Sep 2004 06:55:51 +0000

varconf (0.6.1-2) unstable; urgency=low

  * debian/copyright: Fixed download url and copyright notice
  * debian/rules: Use dh_install instead of dh_movefiles
  * debian/control: Removed redundant Origin tag 

 -- Michael Koch <konqueror@gmx.de>  Mon, 26 Jul 2004 09:02:43 +0200

varconf (0.6.1-1) unstable; urgency=low

  * New upstream release

 -- Michael Koch <konqueror@gmx.de>  Thu, 19 Feb 2004 14:03:51 +0100

varconf (0.6.0-1) unstable; urgency=low

  * New upstream release.
  * Renamed deb files to match library version.
  * Bumped Standards-Version to 3.5.9.

 -- Michael Koch <konqueror@gmx.de>  Fri, 26 Apr 2003 10:43:24 +0100

varconf (0.5.4-5) unstable; urgency=low

  * Regenerated build files (Closes: #176789). 

 -- Michael Koch <konqueror@gmx.de>  Fri, 21 Mar 2003 14:40:11 +0100

varconf (0.5.4-4) unstable; urgency=low

  * c102 transition.
  * Explicitely link to libstdc++.
  * Build-Depend on libsigc++-1.2-dev instead of libsigc++-dev.
  * debian/rules cleanup.

 -- Michael Koch <konqueror@gmx.de>  Fri, 10 Jan 2003 13:08:00 +0100

varconf (0.5.4-3) unstable; urgency=low

  * Build-Conflicts on libsigc++-1.1-dev and libsigc++-1.2-dev.
  * Bumped Standards-Version to 3.5.8.
  * Fixed descriptions in debian/control.
  * Support build option "noopt" in debian/rules.
  * Clean up debian/rules.
  * Added --disable-static to configure call in debian/rules.

 -- Michael Koch <konqueror@gmx.de>  Thu, 12 Dec 2002 18:27:42 +0100

varconf (0.5.4-2) unstable; urgency=low

  * Build-Conflicts to libsigc++-1.1-dev.

 -- Michael Koch <konqueror@gmx.de>  Mon, 23 Sep 2002 15:01:44 +0200

varconf (0.5.4-1) unstable; urgency=low

  * New upstream release
  * Dont Build-Depend on libstdc++-dev


=== debian/control ===
Source: varconf
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen M. Webb <stephen.webb@bregmasoft.ca>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libsigc++-2.0-dev
Standards-Version: 3.9.3
Homepage: http://www.worldforge.org/
Vcs-Git: git://git.debian.org/git/pkg-games/varconf.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/varconf.git

Package: libvarconf-1.0-7
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: WorldForge configuration file handling library
 Varconf is a configuration system designed for the STAGE server. Varconf
 can parse configuration files, command-line arguments and environment
 variables. It supports callbacks and can store its configuration
 information in separate Config objects or in one global configuration
 instance.
 .
 This package contains the shared libraries.

Package: libvarconf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: libsigc++-2.0-dev,
         libvarconf-1.0-7 (= ${binary:Version}),
         ${misc:Depends}
Replaces: libvarconf-1.0-dev
Conflicts: libvarconf-1.0-dev
Description: WorldForge configuration file handling library - development files
 Varconf is a configuration system designed for the STAGE server. Varconf
 can parse configuration files, command-line arguments and environment
 variables. It supports callbacks and can store its configuration
 information in separate Config objects or in one global configuration
 instance.
 .
 This package contains the development files for compiling applications and
 libraries depending on varconf.

Package: libvarconf-1.0-7-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: libvarconf-1.0-7 (= ${binary:Version}),
         ${misc:Depends}
Description: WorldForge configuration file handling library - debugging libraries
 Varconf is a configuration system designed for the STAGE server. Varconf
 can parse configuration files, command-line arguments and environment
 variables. It supports callbacks and can store its configuration
 information in separate Config objects or in one global configuration
 instance.
 .
 This package contains the shared libraries with debugging symbols.

## varconf 1.0.0

=== debian/changelog ===
varconf (1.0.0-2ubuntu1) xenial; urgency=medium

  * Mark one more symbol as optional. Closes: #805239.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 11 Feb 2016 13:18:57 +0100

varconf (1.0.0-2) unstable; urgency=medium

  * Team upload.

  [ Stephen M. Webb ]
  * debian/copyright: update dates

  [ Simon McVittie ]
  * Rename libvarconf-1.0-8 to libvarconf-1.0-8v5 for g++-5 transition.
    Based on Ubuntu patches from Steve Langasek and Daniel T Chen.
    (Closes: #791308)
    - Update symbols file (Closes: #778160)
    - Build-depend on the new ABI of libsigc++-2.0 so everything happens
      in the right order

 -- Simon McVittie <smcv@debian.org>  Tue, 18 Aug 2015 21:01:52 +0100

varconf (1.0.0-1) unstable; urgency=low

  * new upstream release
  * bumped packaging name for new SONAME
  * debian/libvarconf-1.0-8.symbols: adjusted for symbol hiding
  * debian/control: updated Standards-Version to 3.9.4 (updated VCS-* fields)
  * debian/libvarconf-1.0-8.symbols: adjusted for GCC-4.8 (closes: #701369)

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Wed, 05 Jun 2013 11:11:32 -0400

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,20 @@
 Uploaders: Stephen M. Webb <stephen.webb@bregmasoft.ca>
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
-               libsigc++-2.0-dev
-Standards-Version: 3.9.3
+               libsigc++-2.0-dev (>= 2.4.1-2),
+Standards-Version: 3.9.4
 Homepage: http://www.worldforge.org/
-Vcs-Git: git://git.debian.org/git/pkg-games/varconf.git
-Vcs-Browser: http://git.debian.org/?p=pkg-games/varconf.git
+Vcs-Git: git://anonscm.debian.org/pkg-games/varconf.git
+Vcs-Browser: http://anonscm.debian.org/git/pkg-games/varconf.git
 
-Package: libvarconf-1.0-7
+Package: libvarconf-1.0-8v5
 Architecture: any
 Multi-Arch: same
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Conflicts: libvarconf-1.0-8
+Replaces: libvarconf-1.0-8
 Description: WorldForge configuration file handling library
  Varconf is a configuration system designed for the STAGE server. Varconf
  can parse configuration files, command-line arguments and environment
@@ -32,7 +34,7 @@
 Section: libdevel
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Depends: libsigc++-2.0-dev,
-         libvarconf-1.0-7 (= ${binary:Version}),
+         libvarconf-1.0-8v5 (= ${binary:Version}),
          ${misc:Depends}
 Replaces: libvarconf-1.0-dev
 Conflicts: libvarconf-1.0-dev
@@ -46,14 +48,16 @@
  This package contains the development files for compiling applications and
  libraries depending on varconf.
 
-Package: libvarconf-1.0-7-dbg
+Package: libvarconf-1.0-8v5-dbg
 Architecture: any
 Multi-Arch: same
 Section: debug
 Priority: extra
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
-Depends: libvarconf-1.0-7 (= ${binary:Version}),
+Depends: libvarconf-1.0-8v5 (= ${binary:Version}),
          ${misc:Depends}
+Conflicts: libvarconf-1.0-8-dbg
+Replaces: libvarconf-1.0-8-dbg
 Description: WorldForge configuration file handling library - debugging libraries
  Varconf is a configuration system designed for the STAGE server. Varconf
  can parse configuration files, command-line arguments and environment

=== debian/watch ===
version=3
http://sf.net/worldforge/varconf-(.*)\.tar\.gz debian uupdate

## varconf 1.0.1

=== debian/changelog ===
varconf (1.0.1-8) unstable; urgency=high

  * Force build with C++11 standard to fix FTBFS (Closes: #984384)
  * Update standards to 4.6.0 (no changes)
  * Update d/upstream/metadata

 -- Olek Wojnar <olek@debian.org>  Fri, 19 Nov 2021 10:53:33 -0500

varconf (1.0.1-7) unstable; urgency=medium

  * Remove d/symbols due to continued instability (Closes: #957906)
  * Update compatibility mode to 13 (remove d/compat)
  * Update standards to 4.5.0 (no changes)
  * Add Rules-Requires-Root: no

 -- Olek Wojnar <olek@debian.org>  Fri, 31 Jul 2020 20:37:02 -0400

varconf (1.0.1-6) unstable; urgency=high

  * Update d/control: new uploader email and URLs
  * Update d/copyright: refresh debian info
  * Update d/control: remove versioned build dependency on g++
  * Update symbols for GCC-8 (Closes: #897883)
  * Update d/control: standards 4.2.1 (no changes)
  * Update d/compat: 11 (no changes)
  * Remove d/triggers: redundant trigger
  * Add d/upstream/metadata: for DEP 12 compliance
  * Update d/control: migration complete, remove dbgsym-migration flag

 -- Olek Wojnar <olekw.dev@gmail.com>  Wed, 03 Oct 2018 18:36:39 -0400

varconf (1.0.1-5) unstable; urgency=medium

  * Build-depend on g++ >= 4:7 for GCC 7 compliance

 -- Olek Wojnar <olek-dev@wojnar.org>  Tue, 05 Sep 2017 13:10:35 -0500

varconf (1.0.1-4) unstable; urgency=high

  * Update dh compat to 10
  * Update symbols for GCC 7 (Closes: #853388)
  * Update standards to 4.1.0
    - d/control: document new standards version
    - d/copyright: use https in Format field
  * Update d/copyright: new copyright year for debian directory

 -- Olek Wojnar <olek-dev@wojnar.org>  Sat, 02 Sep 2017 22:01:28 -0500

varconf (1.0.1-3) unstable; urgency=high

  * Update symbols for GCC6 (Closes: #831212)

 -- Olek Wojnar <olek-dev@wojnar.org>  Thu, 14 Jul 2016 19:20:47 -0400

varconf (1.0.1-2) unstable; urgency=medium

  * Fix d/control Vcs-Git line

 -- Olek Wojnar <olek-dev@wojnar.org>  Fri, 24 Jun 2016 16:44:13 -0400

varconf (1.0.1-1) unstable; urgency=medium

  * New upstream release
  * Update d/control
    - Fix Vcs-Browser line (Thanks to Tobias Frost)
    - Remove pre-dependency on dpkg
    - Update standards to 3.9.8 (no changes)
  * Add myself as new uploader
    - Remove Stephen Webb per his request
    - Thanks for all the contributions, Stephen!
  * Update symbols (Closes: #805239)
  * Update d/watch: add file extensions potentially used by upstream
  * Update d/rules: remove builddeb override since xz is now default
  * Add d/triggers for proper ldconfig functionality
  * Enable all hardening options
  * Convert to automatic debug package

 -- Olek Wojnar <olek-dev@wojnar.org>  Sat, 11 Jun 2016 20:52:12 -0500

=== debian/control ===
Source: varconf
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Olek Wojnar <olek@debian.org>,
           Debian Games Team <team+pkg-games@tracker.debian.org>,
Build-Depends: debhelper-compat (= 13),
               libsigc++-2.0-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://www.worldforge.org/
Vcs-Git: https://salsa.debian.org/games-team/varconf.git
Vcs-Browser: https://salsa.debian.org/games-team/varconf

Package: libvarconf-1.0-8v5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libvarconf-1.0-8
Replaces: libvarconf-1.0-8
Description: WorldForge configuration file handling library
 Varconf is a configuration system designed for the STAGE server. Varconf
 can parse configuration files, command-line arguments and environment
 variables. It supports callbacks and can store its configuration
 information in separate Config objects or in one global configuration
 instance.
 .
 This package contains the shared libraries.

Package: libvarconf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libsigc++-2.0-dev,
         libvarconf-1.0-8v5 (= ${binary:Version}),
         ${misc:Depends}
Replaces: libvarconf-1.0-dev
Conflicts: libvarconf-1.0-dev
Description: WorldForge configuration file handling library - development files
 Varconf is a configuration system designed for the STAGE server. Varconf
 can parse configuration files, command-line arguments and environment
 variables. It supports callbacks and can store its configuration
 information in separate Config objects or in one global configuration
 instance.
 .
 This package contains the development files for compiling applications and
 libraries depending on varconf.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Version 1.0.1 does not build correctly using the C++17 standard
export DEB_CPPFLAGS_MAINT_APPEND = -std=c++11
%:
	dh $@

override_dh_missing:
	dh_missing -X.la -X.a

=== debian/watch ===
version=4
http://sf.net/worldforge/varconf-(.*)\.(?:tar\.(?:gz|bz2|xz)) debian uupdate

## varconf 1576614834.ae07a67

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(varconf)
include(GNUInstallDirs)
include(FindPkgConfig)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/tools/cmake)

# Version setup

set(VARCONF_VERSION_MAJOR 1)
set(VARCONF_VERSION_MINOR 0)
set(VARCONF_VERSION_PATCH 3)

set(VERSION ${VARCONF_VERSION_MAJOR}.${VARCONF_VERSION_MINOR}.${VARCONF_VERSION_PATCH})
set(SUFFIX -${VARCONF_VERSION_MAJOR}.${VARCONF_VERSION_MINOR})

set(VARCONF_ABI_CURRENT 9)
set(VARCONF_ABI_REVISION 0)
set(VARCONF_ABI_AGE 0)
math(EXPR VARCONF_SOVERSION ${VARCONF_ABI_CURRENT}-${VARCONF_ABI_AGE})
set(VARCONF_ABI_VERSION ${VARCONF_SOVERSION}.${VARCONF_ABI_AGE}.${VARCONF_ABI_REVISION})

option(BUILD_TESTING "Should tests always be built; otherwise they will be built when the 'check' target is executed." OFF)
option(BUILD_SHARED_LIBS "Build libraries as shared as opposed to static." ON)

# Set compiler flags
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(WF_WARNING_FLAGS /W3)
    add_definitions(-D_WIN32_WINNT=0x0601) #target Windows 7
else ()
    set(WF_WARNING_FLAGS -Wall -Winit-self -Wcast-qual -Wwrite-strings -Wextra -Wundef -Wmissing-declarations -Wno-unused-parameter -Wshadow -Wno-missing-field-initializers -Wno-long-long)
endif ()

include_directories("${PROJECT_SOURCE_DIR}/src")

# Meta data

set(DESCRIPTION "Configuration library for the Worldforge system.")


# This macro defines a library
macro(wf_add_library _LIB_NAME _SOURCE_FILES_VAR _HEADER_FILES_VAR)

    add_library(${_LIB_NAME} ${${_SOURCE_FILES_VAR}})
    set_target_properties(${_LIB_NAME} PROPERTIES
            VERSION ${VARCONF_ABI_VERSION}
            SOVERSION ${VARCONF_SOVERSION}
            )
    target_compile_options(${_LIB_NAME} PRIVATE ${WF_WARNING_FLAGS})

    install(TARGETS ${_LIB_NAME}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    foreach (file ${${_HEADER_FILES_VAR}})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION include/${PROJECT_NAME}${SUFFIX}/${dir})
    endforeach ()

    target_link_libraries(${_LIB_NAME} ${WF_LIBRARIES})

endmacro()

# Add a "check" target, which builds and runs the tests.
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

#Macro for adding a test. The test name will be extracted from the name of the first submitted file.
#Additional files can be submitted as varargs.
macro(wf_add_test TEST_FILE)

    get_filename_component(TEST_NAME ${TEST_FILE} NAME_WE)

    # If BUILD_TESTING is defined we'll build the test no matter what. This makes it work better on Windows.
    if (BUILD_TESTING)
        add_executable(${TEST_NAME} ${TEST_FILE} ${ARGN})
    else (BUILD_TESTING)
        add_executable(${TEST_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} ${ARGN})
    endif (BUILD_TESTING)
    target_link_libraries(${TEST_NAME} ${PROJECT_NAME}${SUFFIX})
    add_test(NAME ${TEST_NAME} COMMAND $<TARGET_FILE:${TEST_NAME}>)

    add_dependencies(check ${TEST_NAME})
endmacro()

# Check for deps

set(WF_LIBRARY_DIRS)
set(WF_INCLUDE_DIRS)
set(WF_LIBRARIES)

if (EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
    MESSAGE("Using Conan for dependency resolution.")
    include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
    conan_basic_setup()
endif ()

find_package(SigC++
        2.0
        REQUIRED)
list(APPEND WF_LIBRARIES ${SIGC++_LIBRARY})
list(APPEND WF_LIBRARY_DIRS ${SIGC++_LIBRARY_DIRS})
list(APPEND WF_INCLUDE_DIRS ${SIGC++_INCLUDE_DIR})

link_directories(${WF_LIBRARY_DIRS})
include_directories(${WF_INCLUDE_DIRS})
# Populate for pkg-config
set(REQUIRES "sigc++-2.0")

add_subdirectory(src)
add_subdirectory(tests)

# pkg-config files
configure_file(tools/${PROJECT_NAME}.pc.in ${PROJECT_NAME}${SUFFIX}.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}${SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# RPM spec files
#TODO: fix these
configure_file(tools/${PROJECT_NAME}.spec.in ${PROJECT_NAME}.spec @ONLY)
#TODO: fix these
configure_file(tools/mingw32-${PROJECT_NAME}.spec.in mingw32-${PROJECT_NAME}.spec @ONLY)

# Doxygen support, exports a "dox" target.

find_package(Doxygen)
set(DOXYGEN_INPUT src/varconf)
configure_file(docs/Doxyfile.in Doxyfile @ONLY)

if (DOXYGEN_FOUND)

    set(DOXYGEN_INPUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    set(DOXYGEN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/docs)

    add_custom_command(
            OUTPUT ${DOXYGEN_OUTPUT}
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
            COMMAND ${CMAKE_COMMAND} -E echo "Done."
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${DOXYGEN_INPUT}
    )

    add_custom_target(dox DEPENDS ${DOXYGEN_OUTPUT})

endif (DOXYGEN_FOUND)

add_custom_command(
        OUTPUT ChangeLog
        COMMAND ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR} 8bd480b053190ffde2afe33af66f484953036f5a
)
add_custom_target(changelog DEPENDS ChangeLog)


# CMake config files
include(CMakePackageConfigHelpers)

configure_package_config_file(tools/Config.cmake.in ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
        PATH_VARS CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_LIBDIR)
write_basic_package_version_file(
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
        VERSION ${VERSION}
        COMPATIBILITY ExactVersion)
install(FILES
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})


# Packaging (for source tarballs

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${DESCRIPTION})
set(CPACK_PACKAGE_VENDOR "Worldforge")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${VARCONF_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${VARCONF_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${VARCONF_VERSION_PATCH}")
#set(CPACK_INSTALL_SCRIPT "sh ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CPACK_PACKAGE_INSTALL_DIRECTORY} 8bd480b053190ffde2afe33af66f484953036f5a")

set(CPACK_SOURCE_GENERATOR TBZ2 ZIP)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}" CACHE INTERNAL "tarball basename")

set(CPACK_SOURCE_IGNORE_FILES
        # no hidden files
        "/\\\\..+$"
        "~$"
        )

include(CPack)

=== src/CMakeLists.txt ===
set(SOURCE_FILES
        varconf/config.cpp
        varconf/dynbase.cpp
        varconf/dyncmp.cpp
        varconf/dyntypes.cpp
        varconf/parse_error.cpp
        varconf/varconf.h
        varconf/variable.cpp)

set(HEADER_FILES
        varconf/config.h
        varconf/dynbase.h
        varconf/dyncmp.h
        varconf/dyntypes.h
        varconf/dynvar.h
        varconf/parse_error.h
        varconf/varconf.h
        varconf/varconf_defs.h
        varconf/variable.h)

wf_add_library(${PROJECT_NAME}${SUFFIX} SOURCE_FILES HEADER_FILES)
target_compile_options("${PROJECT_NAME}${SUFFIX}" PRIVATE ${WF_WARNING_FLAGS})

=== tests/CMakeLists.txt ===
enable_testing()

wf_add_test(conftest.cpp)
add_definitions(-DSRCDIR="${PROJECT_SOURCE_DIR}/tests")
